"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _underscore = _interopRequireDefault(require("underscore"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class EventListenerCollection {
  constructor() {
    _defineProperty(this, "listenerCollection", []);
  }
  emitEvent(valueToEmit) {
    if (this.listenerCollection && this.listenerCollection.length > 0) {
      for (const aListener of this.listenerCollection) {
        if (aListener) {
          aListener(valueToEmit);
        }
      }
    }
  }
  addListener(callback) {
    if (!_underscore.default.contains(this.listenerCollection, callback)) {
      this.listenerCollection.push(callback);
    }
  }
  removeListener(callback) {
    if (_underscore.default.contains(this.listenerCollection, callback)) {
      this.listenerCollection = _underscore.default.reject(this.listenerCollection, item => item === callback);
    }
  }
  hasListeners() {
    return this.listenerCollection.length > 0;
  }
}
exports.default = EventListenerCollection;
//# sourceMappingURL=EventListenerCollection.js.map